***********************************************************************
* PROGRAMA DE CONSULTA, CADASTRO E COMPRA DE PRODUTOS
* PARA TR-100 
*
* Utiliza uma base de dados (lista.dbf) onde esto cadastrados os 
* produtos, preos e cdigos.
* Um arquivo de indice (lista.ntx)
* Um arquivo texto (compra.txt) para armazenar os produtos vendidos, 
* seus preos e o numero de cada venda. 
*
***********************************************************************   

************************************************************
* DECLARAO DE VARIAVEIS
************************************************************
N1=0
N2=0
N5=0
C1=SPACE(15)
C3=SPACE(5)
COD=0
A = 0
t = .T.
SOMA=0
QUANT=0
SOMA1=0
QUANT1=0
VA=0
FIM=0
T2=.T.
I=0
COD2=0
NADA=0
FLAG=.T.
HORA=SPACE(8)
DATA1=SPACE(10)
P=0

************************************************************
* VETORES PARA ARMAZENAR ITENS COMPRADOS
************************************************************
DECLARE PRODUTOS(100,15)
DECLARE PRECOS(100,5)
************************************************************
* VARIAVEIS UTILIZADAS NA PROCEDURE LETRA
************************************************************
XCONT=0
LET=SPACE(1)
C2=SPACE(2)
N3=0
N4=0
A=0
A2=0
PA=SPACE(15)
I=0
APAGA=SPACE(10)
************************************************************
* VARIAVEIS UTILIZADAS PARA ESCREVER DADOS NO ARQUIVO TEXTO
************************************************************
ARQUIVO=0
LF=""
LF=CHR(10)
PRE=SPACE(6)
QUA=SPACE(3)
QUA2=SPACE(2)
QUAVE=0
VENDA=SPACE(6)
COD=1
************************************************************
* INICIO DO APLICATIVO
************************************************************

@1,1 SAY "INICIALIZANDO..."
DATA=DATE()
DATA1=DTOC(DATA)
HORA=TIME()
@2,1 SAY DATA1
@2,12 SAY HORA
DO DELAY

DO LIMPA
USE LISTA INDEX LISTA
DO CADASTRAR

QUIT

*********************************************************************
PROCEDURE CADASTRAR
*********************************************************************
DO WHILE T=.T.



	@1,1 SAY "VER LISTA: 1"
	@2,1 SAY "CADASTRAR: 2"


	P=INKEY()

	DO CASE
		CASE P=49	
			DO LIMPA
			DO INICIO
	
		CASE P=50
			DO LIMPA
			DO ALTERAR		
	ENDCASE
ENDDO
RETURN

*********************************************************************
PROCEDURE INICIO
*********************************************************************
DO LIMPA	
USE LISTA INDEX LISTA

T=.T.
DO WHILE T = .T.
	DO LIMPA2
	@2,1 SAY "T:"
	@2,3 SAY SOMA
	@2,11 SAY "MENU>6"
	SET KEY -3 TO
		
	SEEK COD	
	FLAG=FOUND()
	CLEAR TYPEAHEAD
	IF FLAG=.F.
		@1,1 SAY "NENHUM PRODUTO "	
		@2,1 SAY "FOI CADASTRADO!"	
		DO DELAY
		DO CADASTRAR	
	ENDIF

	N1=CODIGO
	N2=PRECO
	C1=NOME
	
	@1,17 SAY COD
	@1,1 SAY C1
	@1,12 SAY N2

	A=INKEY(0)
	
	DO CASE 
		CASE A=54
			DO MENU
        	CASE A=-1
			DO VOLTA
		CASE A=-2
			DO ALTERAR
		CASE A=-3
			DO ENCERRA
	        CASE A=49
			COD=COD+1	&& Se o digito for 1 mostra
        	CASE A=48		&& prximo produto
			COD=COD-1	&& se o digito for 0 mostra
	ENDCASE				&& produto anterior
	SEEK COD
	FLAG=FOUND()
     
	DO CASE 
		CASE COD=0		 
			GO BOTTOM	
			COD=CODIGO
		CASE FLAG=.F.
			COD=1
	ENDCASE
      
ENDDO

RETURN

*********************************************************************
PROCEDURE MENU
*********************************************************************
DO LIMPA
@1,1 SAY "F1-ADIC."
@2,1 SAY "F2-CADASTRAR"
@1,11 SAY "F3-FIM"
DO DELAY
DO DELAY
DO LIMPA
RETURN
*********************************************************************
PROCEDURE ALTERAR
*********************************************************************
DO LIMPA  
SET KEY -3 TO INICIO	
	
*ALTERACAO DE PRODUTO*
DO LIMPA
@1,1 SAY "NOVO PRODUTO:"
DO LETRA 

*ALTERACAO DE PRECO*
VA=0
DO LIMPA
SET CURSOR ON
@1,9 SAY "LISTA-F3"
@1,1 SAY "VALOR:"
@2,1 GET VA
SET CURSOR OFF
GO BOTTOM
COD=CODIGO
COD=COD+1
APPEND BLANK
REPLACE CODIGO WITH COD 
REPLACE NOME WITH PA
REPLACE PRECO WITH VA
T=.T.

DO LIMPA
DO INICIO
RETURN
*********************************************************************
PROCEDURE ENCERRA
*********************************************************************
DO LIMPA
  
@1,1 SAY " EXIBIR COMPRAS "
@2,1 SAY "  SIM>1  NAO>2  "

FIM=INKEY(0)
DO CASE
	CASE FIM=49 .AND. QUANT<1
		*T2=.T.
		DO LIMPA
		@1,1 SAY "NENHUM PRODUTO "
		@2,1 SAY "FOI ADICIONADO!"
		DO DELAY
		DO INICIO  
	
	CASE FIM=49

		DO WHILE T2 = .T.
			DO LIMPA
			C1=PRODUTOS[N5]
			C3=PRECOS[N5]

			@1,17 SAY N5 
			@1,1 SAY C1
			@1,12 SAY C3
			@2,1 SAY "T:"
			@2,3 SAY SOMA
			@2,10 SAY "VOLTA>8"
			A=INKEY(0)
	
			DO CASE 
				CASE A=49  
					N5=N5+1
				CASE A=48
					N5=N5-1
				CASE A=56
					DO ENCERRA
					T2=.F.
			ENDCASE

			DO CASE 
				CASE N5=0
					N5=QUANT
				CASE N5>QUANT
					N5=1
			ENDCASE  
		ENDDO
	CASE FIM=50
ENDCASE

@1,1 SAY "  ENCERRA DIA?  "
@2,1 SAY "  SIM>1  NAO>2  "
FIM=INKEY(0)
DO CASE
	CASE FIM=50
		N5=0  		
		QUANT=0		
		SOMA=0
  		DO INICIO
	CASE FIM=49
		DO LIMPA

		DO WHILE T=.T.  
			@1,1 SAY "   TOTAL:"
			@2,1 SAY "QUANTID.:"
			@1,10 SAY SOMA1
			@2,10 SAY QUANT1
		ENDDO
		WAIT
		DO LIMPA
		SOMA1=0  
		QUANT1=0

	OTHERWISE
		DO ENCERRA
				
ENDCASE
  
 
RETURN

*********************************************************************
PROCEDURE VOLTA
*********************************************************************
DO LIMPA
*NADA=1
N5=N5+1
C3=STR(N2,5,2)

VENDA="VENDAS"   
PRODUTOS[N5]=C1
PRECOS[N5]=C3

SOMA=SOMA + N2
QUANT=QUANT +1
SOMA1=SOMA1 + N2
QUANT1=QUANT1 + 1 
QUA=STR(QUANT,3,0)

@1,1 SAY "VALOR T.:"
@2,1 SAY "QUANTID.:" 
@1,10 SAY SOMA
@2,10 SAY QUANT
DO CASE
	CASE QUANT < 2
		QUAVE=QUAVE+1
		QUA2=STR(QUAVE,2,0)	  

		ARQUIVO=FOPEN("COMPRA.TXT")     && Pula linha
		FSEEK(ARQUIVO,0,2)
		FWRITE(ARQUIVO,LF,1)
		FCLOSE(ARQUIVO)	

		ARQUIVO=FOPEN("COMPRA.TXT")     && Escreve venda e o
		FSEEK(ARQUIVO,0,2)		&& numero
		FWRITE(ARQUIVO,VENDA,7)
		FWRITE(ARQUIVO,QUA2,2)
		FWRITE(ARQUIVO,LF,1)
		FCLOSE(ARQUIVO)	

		ARQUIVO=FOPEN("COMPRA.TXT")     && Escreve o produto 1
		FSEEK(ARQUIVO,0,2)		&& vendido e o preo
		FWRITE(ARQUIVO,QUA,4)
		FWRITE(ARQUIVO,C1,15)
		FWRITE(ARQUIVO,C3,6)
		FWRITE(ARQUIVO,LF,1)
		FCLOSE(ARQUIVO)  

	CASE QUANT > 1
		ARQUIVO=FOPEN("COMPRA.TXT")	&& Escreve os produtos
		FSEEK(ARQUIVO,0,2)		&& vendidos at que a 
		FWRITE(ARQUIVO,QUA,4)		&& venda seja finalizada
		FWRITE(ARQUIVO,C1,15)
		FWRITE(ARQUIVO,C3,6)
		FWRITE(ARQUIVO,LF,1)
		FCLOSE(ARQUIVO)
ENDCASE

*DO DELAY    
DO INICIO
RETURN

*********************************************************************
PROCEDURE LETRA
* Funciona como um teclado de celular para escrever o nome do produto
* que ser cadastrado
*********************************************************************

T=.T.
PA=""
LET=""
N3=0
N4=0
A=0
A2=0
XCONT=0

DO WHILE T=.T.
	@2,11 SAY "      "
	FLAG=.T.
	A2=A
	A=0
	I=0

	FOR I=1 TO 20			
		A=INKEY()		&& funcao com aproximadamente 
		IF A>0			&& 2 segundos para utilizar
			EXIT		&& a segunda ou terceira letra
		ENDIF			&& da tecla
	NEXT
	IF A=0				&& passados os 2 segundos
		A=INKEY(0)		&& vem para esta funo
	ENDIF
					&& avanando uma posio no 
	DO CASE				&& display
		CASE A=-1
			LOOP
		CASE A=-2
			LOOP
		CASE A=-3
			DO INICIO	
	ENDCASE
	IF A2=A				&& Conta quantas vezes a mesma
		XCONT=XCONT+1		&& tecla foi digitada
	ELSE
		XCONT=1
	ENDIF
					&& Entra nesse if sempre um loop
	IF A2=8				&& aps o digito			
		DO CASE			
			CASE XCONT=1 .AND. I>19	&& Condies necessarias	
				FLAG=.T.	&& para voltar uma 	
			CASE XCONT>1 .AND. I>19	&& posio a cada			
				FLAG=.T. 	&& vez que a tecla
			CASE XCONT=1 .AND. I<20	&& anula for digitada			
				FLAG=.T.
			OTHERWISE
				FLAG=.F.
				
		ENDCASE
	ELSE
		DO CASE
			CASE XCONT=1 .AND. I>19 && nessas 3 condies 
				N3=N3+1		&& avana para
				FLAG=.T.	&& proxima posio
				XCONT=1		&& e a variavel PA	
			CASE XCONT>1 .AND. I>19 && recebe a letra
				N3=N3+1		&& digitada
				FLAG=.T. 
				XCONT=1
			CASE XCONT=1 .AND. I<20
				N3=N3+1
				FLAG=.T.
				XCONT=1
			OTHERWISE
				FLAG=.F.
				
		ENDCASE
	ENDIF
	IF A=8				&& apaga uma posio no display 
		LET=""			&& e na variavel PA
		N4=N4-1
		N3=N3-1								
		APAGA=" "
		PA=SUBSTR(PA,1,N4)
	ENDIF
	IF FLAG=.T. .AND. A<>8		&& Escreve na variavel PA 
		N4=N4+1			&& a letra digitada
		PA=PA+LET
	ENDIF
	DO CASE
		CASE A=13		&& se digitar enter sai do loop
			T=.F.				
			DO LIMPA
		CASE A=48
			DO CASE
				CASE XCONT=1					
					LET=" "
				CASE XCONT=2
					LET="-"
				CASE XCONT=3
					LET="/"
				CASE XCONT=4
					LET="_"	
			ENDCASE
		CASE A=49
			DO CASE
				CASE XCONT=1
					LET="Q"					
				CASE XCONT=2
					LET="Z"
				CASE XCONT=3
					LET="1"
			ENDCASE
		CASE A=50
			DO CASE
				CASE XCONT=1
					LET="A"					
				CASE XCONT=2
					LET="B"
				CASE XCONT=3
					LET="C"
				CASE XCONT=4
					LET="2"	
			ENDCASE
		CASE A=51
			DO CASE
				CASE XCONT=1
					LET="D"					
				CASE XCONT=2
					LET="E"
				CASE XCONT=3
					LET="F"
				CASE XCONT=4
					LET="3"	
			ENDCASE
		CASE A=52
			DO CASE
				CASE XCONT=1
					LET="G"					
				CASE XCONT=2
					LET="H"
				CASE XCONT=3
					LET="I"
				CASE XCONT=4
					LET="4"	
			ENDCASE
		CASE A=53
			DO CASE
				CASE XCONT=1
					LET="J"
				CASE XCONT=2
					LET="K"
				CASE XCONT=3
					LET="L"
				CASE XCONT=4
					LET="5"
			ENDCASE
		CASE A=54
			DO CASE
				CASE XCONT=1
					LET="M"						
				CASE XCONT=2
					LET="N"
				CASE XCONT=3
					LET="O"
				CASE XCONT=4
					LET="6"	
			ENDCASE
		CASE A=55
			DO CASE
				CASE XCONT=1
					LET="P"					
				CASE XCONT=2
					LET="R"
				CASE XCONT=3
					LET="S"
				CASE XCONT=4
					LET="7"	
			ENDCASE
		CASE A=56
			DO CASE
				CASE XCONT=1
					LET="T"
				CASE XCONT=2
					LET="U"
				CASE XCONT=3
					LET="V"
				CASE XCONT=4
					LET="8"	
			ENDCASE
		CASE A=57
			DO CASE
				CASE XCONT=1
					LET="W"					
				CASE XCONT=2
					LET="X"
				CASE XCONT=3
					LET="Y"
				CASE XCONT=4
					LET="9"	
			ENDCASE
	ENDCASE
	IF N3=11
		LET=""
		N3=10
	ENDIF
	IF N3<=0	&& N3 nunca ser = 0 ou negativo
		N3=1		
	ENDIF
	IF N4<=0
		N4=0
		PA=""
	ENDIF

	IF A=8
		@2,N3 SAY APAGA	
	ELSE
		@2,N3 SAY LET
	ENDIF
	IF XCONT=4
		XCONT=0
	ENDIF

ENDDO
RETURN

*********************************************************************
PROCEDURE LIMPA
*********************************************************************
@ 1,1 SAY "                 "
@ 2,1 SAY "                 "
RETURN

*********************************************************************
PROCEDURE DELAY
*********************************************************************
 FOR i=0 to 100
 NEXT
RETURN
*********************************************************************
PROCEDURE LIMPA2
*********************************************************************
@ 1,1 SAY "                 "

RETURN